<?php

// Set PHP time limit to 14 minutes just in case (840 seconds)
set_time_limit(840);

// Include Medoo framework (http://medoo.in)
require_once('medoo.php');

use Medoo\Medoo;
 
// CSRF database location
$db_csrf = new Medoo([
	'database_type' => 'sqlite',
	'database_file' => '/path/for/csrf_table.sqlite.db'
]);

//__________________________

// Get all rows
if ( $datas = $db_csrf->select("csrf_table", [

	"csrf_id",
	"csrf_hash",
	"csrf_date"
], [
	"csrf_id[>]" => 0
]) )
// Success: found some rows
{
	echo '0';
}
// Error: no rows found
else {
	echo '1';
}

// Process rows
foreach($datas as $data)
{

	// Delete entries older than 24 hours (1440 seconds)
	if ($data["csrf_date"] < time()-1440) {
			
			$db_csrf->delete("csrf_table", [ "csrf_id" => $data["csrf_id"] ]);
	}
}


?>